#include <stdio.h>
#include <stdlib.h>

typedef struct _POLIGON POLIGON;

struct _POLIGON
{
	char data;
	POLIGON *next;
	POLIGON *priv;
};

POLIGON *element(char c)
{
	POLIGON *temp;
	
	temp = (POLIGON *) malloc(sizeof(POLIGON));
	
	if(!temp)
	{
		perror("Greska u alociranju\n");
		exit(1);
	}
	
	temp->data = c;
	temp->next = NULL;
	temp->priv = NULL;
	
	return temp;
}

void novi(POLIGON **p, POLIGON **k, char c)
{
	POLIGON *temp;
	temp = element(c);
	
	if (!(*p))
	{
		*p = temp;
		*k = temp;
	}
	else
	{
		(*k)->next = temp;
		temp->priv = *k;
		*k = temp;
	}
}

void form(char *file, POLIGON **p, POLIGON **k)
{
	POLIGON *poc, *kraj;
	FILE *f;
	char c;
	poc = NULL;
	kraj = NULL;
	
	f = fopen(file, "r");
	
	c = fgetc(f);
	fgetc(f);
	while(c != '0')
	{
		novi(&poc, &kraj, c);
		c = fgetc(f);
		fgetc(f);
	}
	
	*p = poc;
	*k = kraj;
	fclose(f);
}

void stampa(POLIGON *p)
{
	while (p->next)
	{
		printf("%2c", p->data);
		p = p->next;
	}
	printf("%2c", p->data);
	printf("\n");
}

int prelaz(POLIGON *p, POLIGON *k)
{
	int n = 0;
	if (p->data == 'C')
		return 0;
	
	if (k->data != 'C')
		return 0;
	
	while (p != k)
	{
		if (p->data == 'C')
			n--;
		else
			n++;
		p->data = 'P';
		if (n < 0)
			break;
		p = p->next;
	}
	
	if (n < 0)
		return 0;
	else
		return 1;
}

int main(int argc, char **argv)
{
	if (argc != 2)
	{
		perror("Lose prosledjeni parametri.\n");
		exit(1);
	}
	
	POLIGON *poc, *kraj;
	
	form(argv[1], &poc, &kraj);
	stampa(poc);
	
	if (prelaz(poc, kraj))
		printf("Cilj\n");
	else
		printf("Diskvalifikovan\n");
	
	stampa(poc);
	
	return 0;
}
